package com.hisschemoller.controller 
{
	import com.hisschemoller.model.AudioDriverProxy;
	import com.hisschemoller.utils.audio.vo.SoundVO;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	import flash.utils.ByteArray;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 10, 2010
	 */
	public class ReverseSampleCommand extends SimpleCommand implements ICommand
	{
		override public function execute(notification : INotification) : void
		{
			var soundVO : SoundVO = SoundVO(notification.getBody());
			
			/** Reverse the order of samples in samplerPresetVO.soundData.byteArray. */
			var bytesPerSample : int = AudioDriverProxy.BYTES_PER_SAMPLE;
			var numBytes : Number = soundVO.numSamplesTotal * bytesPerSample;
			var tempByteArray : ByteArray = new ByteArray();
			soundVO.byteArray.position = 0;
			tempByteArray.writeBytes(soundVO.byteArray);
			soundVO.byteArray.position = 0;
			
			for(var offset : Number = (numBytes - bytesPerSample); offset >= 0; offset -= bytesPerSample)
			{
				soundVO.byteArray.writeBytes(tempByteArray, offset, bytesPerSample);
			}
		}
	}
}
