package com.hisschemoller.model 
{
	import com.hisschemoller.utils.audio.processors.IAudioInstrument;

	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.proxy.Proxy;

	/**
	 * @author Wouter Hisschemöller
	 * (c) Jul 17, 2009
	 */
	public class AudioEngineProxy extends Proxy implements IProxy 
	{
		public static const NAME : String = "AudioEngineProxy";
		private var _instruments : Vector.<IAudioInstrument> = new Vector.<IAudioInstrument>();
		private var _selectedInstrumentIndex : uint;

		public function AudioEngineProxy()
		{
			super(NAME);
		}

		/**
		 * @param buffer : stereo buffer of AudioDriver.BUFFER_SIZE number of samples
		 * @param bufferStartIndex : From where in the buffer to start to write.
		 */
		public function process(buffer : Vector.<Vector.<Number>>, bufferStartIndex : uint) : void
		{
			var n : int = _instruments.length;
			while(--n > -1)
			{
				_instruments[n].process(buffer, bufferStartIndex);
			}
		}
		
		/**
		 * 
		 */
		public function addInstrument(instrument : IAudioInstrument) : void
		{
			_instruments.push(instrument);
			_selectedInstrumentIndex = _instruments.length - 1;
		}
		
		/**
		 * 
		 */
		public function removeInstrument() : void
		{
			log("IMPLEMENT removeInstrument");
			/** Remember to update _selectedInstrumentIndex. */
		}
		
		/**
		 * 
		 */
		public function getInstrumentByID(id : String) : IAudioInstrument
		{
			var n : int = _instruments.length;
			while(--n > -1)
			{
				if(_instruments[n].id == id) return _instruments[n];
			}
			
			return null;
		}
	}
}
