package com.hisschemoller.view 
{
	import com.hisschemoller.App;
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.model.WaveDisplayProxy;
	import com.hisschemoller.view.components.WaveEditor;
	
	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;	
	/**
	 * @author wouter.hisschemoller
	 * (c) Feb 24, 2010
	 */
	public class AppMediator extends Mediator implements IMediator 
	{
		public static const NAME : String = "AppMediator";
		
		public function AppMediator(viewComponent : Object)
		{
			super(NAME, viewComponent);
		}

		/**
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [ AppFacade.ADD_INSTRUMENT];
		}

		/**
		 * 
		 */
		override public function handleNotification(notification : INotification) : void
		{
			switch(notification.getName())
			{
				case AppFacade.ADD_INSTRUMENT:
					var name : String = String(notification.getBody());
					var waveEditor : WaveEditor = new WaveEditor(app.editorContainer);
					facade.registerMediator(new WaveEditorMediator(name, waveEditor));
					facade.registerMediator(new WaveControlsMediator(name + WaveControlsMediator.NAME_SUFFIX, waveEditor.waveControls));
					facade.registerMediator(new WaveDisplayMediator(name + WaveDisplayProxy.NAME_SUFFIX, waveEditor.waveDisplay));
					break;
			}
		}

		/**
		 * 
		 */
		private function get app() : App
		{
			return viewComponent as App;
		}
	}
}
