package com.hisschemoller.view.components.ui 
{
	import flash.display.DisplayObjectContainer;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Mar 19, 2010
	 */
	public class TextKeyButton extends TextButton 
	{
		protected var _keyCode : uint;
		protected var _keyDown : Boolean;
		protected var _defaultHandler : Function;
		
		public function TextKeyButton(parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, label : String = "", defaultHandler : Function = null, keyCode : uint = 0)
		{
			_defaultHandler = defaultHandler;
			_keyCode = keyCode;
			
			super(parent, xpos, ypos, label, defaultHandler);
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			super.addChildren();
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyboardEventHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyboardEventHandler);
		}

		/**
		 * 
		 */
		protected function keyboardEventHandler(event : KeyboardEvent) : void
		{
			if(event.keyCode == _keyCode)
			{
				switch(event.type)
				{
					case KeyboardEvent.KEY_DOWN:
						if(!_keyDown)
						{
							onMouseDown(new MouseEvent(MouseEvent.MOUSE_DOWN));
							dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));
						}
						_keyDown = true;
						break;
					
					case KeyboardEvent.KEY_UP:
						onMouseUp(new MouseEvent(MouseEvent.MOUSE_UP));
						onMouseOut(new MouseEvent(MouseEvent.ROLL_OUT));
						if(_defaultHandler != null) _defaultHandler(new MouseEvent(MouseEvent.CLICK));
						_keyDown = false;
						dispatchEvent(new MouseEvent(MouseEvent.MOUSE_UP));
						break;
				}
			}
		}
	}
}
